Debian Bug report logs - #677260
xserver-xorg-video-openchrome: FTBFS[kfreebsd]: error: unknown type name 'uint8_t'

version graph

Package: src:xserver-xorg-video-openchrome; Maintainer for src:xserver-xorg-video-openchrome is Debian X Strike Force <debian-x@lists.debian.org>;

Reported by: debian-bsd@lists.debian.org

Date: Tue, 12 Jun 2012 16:30:02 UTC

Severity: serious

Tags: patch, sid, wheezy

Found in version xserver-xorg-video-openchrome/1:0.2.906-1

Fixed in version xserver-xorg-video-openchrome/1:0.2.906-2

Done: Julien Cristau <jcristau@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, debian-bsd@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#677260; Package src:xserver-xorg-video-openchrome. (Tue, 12 Jun 2012 16:30:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to debian-bsd@lists.debian.org:
New Bug report received and forwarded. Copy sent to debian-bsd@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>. (Tue, 12 Jun 2012 16:30:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Christoph Egger <christoph@debian.org>
To: submit@bugs.debian.org
Subject: xserver-xorg-video-openchrome: FTBFS[kfreebsd]: error: unknown type name 'uint8_t'
Date: Tue, 12 Jun 2012 18:26:17 +0200
Package: src:xserver-xorg-video-openchrome
Version: 1:0.2.906-1
Severity: serious
Tags: sid wheezy
User: debian-bsd@lists.debian.org
Usertags: kfreebsd
X-Debbugs-Cc: debian-bsd@lists.debian.org
Justification: fails to build from source (but built successfully in the past)

Hi!

Your package failed to build on the kfreebsd-* buildds:

In file included from /usr/include/libdrm/via_drm.h:27:0,
                 from ../../src/via_xvmc.h:29,
                 from ../../libxvmc/viaXvMCPriv.h:34,
                 from ../../libxvmc/viaLowLevel.c:34:
/usr/include/libdrm/drm.h:50:1: error: unknown type name 'uint8_t'
/usr/include/libdrm/drm.h:52:1: error: unknown type name 'uint16_t'
/usr/include/libdrm/drm.h:54:1: error: unknown type name 'uint32_t'
/usr/include/libdrm/drm.h:56:1: error: unknown type name 'uint64_t'
make[3]: *** [libchromeXvMC_la-viaLowLevel.lo] Error 1

Full build log at
https://buildd.debian.org/status/fetch.php?pkg=xserver-xorg-video-openchrome&arch=kfreebsd-i386&ver=1%3A0.2.906-1&stamp=1339164249

Regards

    Christoph

If you have further questions please mail debian-bsd@lists.debian.org

-- 
9FED 5C6C E206 B70A 5857  70CA 9655 22B9 D49A E731
Debian Developer | Lisp Hacker | CaCert Assurer




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#677260; Package src:xserver-xorg-video-openchrome. (Tue, 12 Jun 2012 18:48:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Tue, 12 Jun 2012 18:48:05 GMT) Full text and rfc822 format available.

Message #10 received at 677260@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: debian-bsd@lists.debian.org, 677260@bugs.debian.org
Subject: Re: Bug#677260: xserver-xorg-video-openchrome: FTBFS[kfreebsd]: error: unknown type name 'uint8_t'
Date: Tue, 12 Jun 2012 20:44:56 +0200
On Tue, Jun 12, 2012 at 18:26:17 +0200, Christoph Egger wrote:

> Package: src:xserver-xorg-video-openchrome
> Version: 1:0.2.906-1
> Severity: serious
> Tags: sid wheezy
> User: debian-bsd@lists.debian.org
> Usertags: kfreebsd
> X-Debbugs-Cc: debian-bsd@lists.debian.org
> Justification: fails to build from source (but built successfully in the past)
> 
> Hi!
> 
> Your package failed to build on the kfreebsd-* buildds:
> 
> In file included from /usr/include/libdrm/via_drm.h:27:0,
>                  from ../../src/via_xvmc.h:29,
>                  from ../../libxvmc/viaXvMCPriv.h:34,
>                  from ../../libxvmc/viaLowLevel.c:34:
> /usr/include/libdrm/drm.h:50:1: error: unknown type name 'uint8_t'
> /usr/include/libdrm/drm.h:52:1: error: unknown type name 'uint16_t'
> /usr/include/libdrm/drm.h:54:1: error: unknown type name 'uint32_t'
> /usr/include/libdrm/drm.h:56:1: error: unknown type name 'uint64_t'
> make[3]: *** [libchromeXvMC_la-viaLowLevel.lo] Error 1
> 
Does freebsd <sys/types.h> no longer define those types?  That sounds
like a regression there, not in this package.

Cheers,
Julien




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#677260; Package src:xserver-xorg-video-openchrome. (Tue, 12 Jun 2012 21:00:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Tue, 12 Jun 2012 21:00:05 GMT) Full text and rfc822 format available.

Message #15 received at 677260@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Julien Cristau <jcristau@debian.org>
Cc: debian-bsd@lists.debian.org, 677260@bugs.debian.org
Subject: Re: Bug#677260: xserver-xorg-video-openchrome: FTBFS[kfreebsd]: error: unknown type name 'uint8_t'
Date: Tue, 12 Jun 2012 21:57:38 +0100
On 12/06/12 19:44, Julien Cristau wrote:
>> In file included from /usr/include/libdrm/via_drm.h:27:0,
>>                  from ../../src/via_xvmc.h:29,
>>                  from ../../libxvmc/viaXvMCPriv.h:34,
>>                  from ../../libxvmc/viaLowLevel.c:34:
>> /usr/include/libdrm/drm.h:50:1: error: unknown type name 'uint8_t'
>> /usr/include/libdrm/drm.h:52:1: error: unknown type name 'uint16_t'
>> /usr/include/libdrm/drm.h:54:1: error: unknown type name 'uint32_t'
>> /usr/include/libdrm/drm.h:56:1: error: unknown type name 'uint64_t'
>> make[3]: *** [libchromeXvMC_la-viaLowLevel.lo] Error 1
>>
> Does freebsd <sys/types.h> no longer define those types?  That sounds
> like a regression there, not in this package.

Hi Julien,

They're in stdint.h, and that is not being included any more.

This used to happen when a bundled via_drm.h included via_drmclient.h.
Now the system's <libdrm/via_drm.h> has replaced it, but that includes
drm.h before via_drmclient.h, using the C99 integer types without
including stdint.h first.

Therefore the openchrome 0.2.904+svn1050 package (still) builds on
kfreebsd-* whereas 0.2.906 does not.  This seems to be a bug for the
libdrm-dev package.

Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#677260; Package src:xserver-xorg-video-openchrome. (Tue, 12 Jun 2012 21:27:26 GMT) Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Tue, 12 Jun 2012 21:27:26 GMT) Full text and rfc822 format available.

Message #20 received at 677260@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: Steven Chamberlain <steven@pyro.eu.org>
Cc: debian-bsd@lists.debian.org, 677260@bugs.debian.org
Subject: Re: Bug#677260: xserver-xorg-video-openchrome: FTBFS[kfreebsd]: error: unknown type name 'uint8_t'
Date: Tue, 12 Jun 2012 23:19:53 +0200
On Tue, Jun 12, 2012 at 21:57:38 +0100, Steven Chamberlain wrote:

> On 12/06/12 19:44, Julien Cristau wrote:
> >> In file included from /usr/include/libdrm/via_drm.h:27:0,
> >>                  from ../../src/via_xvmc.h:29,
> >>                  from ../../libxvmc/viaXvMCPriv.h:34,
> >>                  from ../../libxvmc/viaLowLevel.c:34:
> >> /usr/include/libdrm/drm.h:50:1: error: unknown type name 'uint8_t'
> >> /usr/include/libdrm/drm.h:52:1: error: unknown type name 'uint16_t'
> >> /usr/include/libdrm/drm.h:54:1: error: unknown type name 'uint32_t'
> >> /usr/include/libdrm/drm.h:56:1: error: unknown type name 'uint64_t'
> >> make[3]: *** [libchromeXvMC_la-viaLowLevel.lo] Error 1
> >>
> > Does freebsd <sys/types.h> no longer define those types?  That sounds
> > like a regression there, not in this package.
> 
> Hi Julien,
> 
> They're in stdint.h, and that is not being included any more.
> 
stdint.h is a userspace header though, I assume it's not available in
kernel space?

> This used to happen when a bundled via_drm.h included via_drmclient.h.
> Now the system's <libdrm/via_drm.h> has replaced it, but that includes
> drm.h before via_drmclient.h, using the C99 integer types without
> including stdint.h first.
> 
> Therefore the openchrome 0.2.904+svn1050 package (still) builds on
> kfreebsd-* whereas 0.2.906 does not.  This seems to be a bug for the
> libdrm-dev package.
> 
Then I'm going to ask for a patch, because drm.h is supposed to work on
all of linux and freebsd kernel and userland, which means it either got
b0rked by kfreebsd or by a freebsd update, AFAICT.

Cheers,
Julien




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#677260; Package src:xserver-xorg-video-openchrome. (Tue, 12 Jun 2012 22:03:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Tue, 12 Jun 2012 22:03:07 GMT) Full text and rfc822 format available.

Message #25 received at 677260@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Julien Cristau <jcristau@debian.org>
Cc: debian-bsd@lists.debian.org, 677260@bugs.debian.org
Subject: Re: Bug#677260: xserver-xorg-video-openchrome: FTBFS[kfreebsd]: error: unknown type name 'uint8_t'
Date: Tue, 12 Jun 2012 23:00:56 +0100
On 12/06/12 22:19, Julien Cristau wrote:
> stdint.h is a userspace header though, I assume it's not available in
> kernel space?

I don't know.  But that is where the via_drm.h bundled in openchrome
0.2.904+svn1050 was getting those definitions from.


This commit shows when via_drm.h (as it is now shipped in libdrm-dev)
became broken at some point:

http://anonscm.debian.org/gitweb/?p=pkg-xorg/lib/libdrm.git;a=commitdiff;h=82bf52fbcdf1e71840c2024bb2bc05a8daeaafad

And this change (I wouldn't call it a patch, I doubt it is correct)
seems to fix it so that openchrome_drv can build again:

 --- /usr/include/libdrm/drm.h.orig
 +++ /usr/include/libdrm/drm.h
 @@ -46,6 +46,7 @@

  #include <sys/ioccom.h>
  #include <sys/types.h>
 +#include <stdint.h>
  typedef int8_t   __s8;
  typedef uint8_t  __u8;
  typedef int16_t  __s16;

Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#677260; Package src:xserver-xorg-video-openchrome. (Tue, 12 Jun 2012 22:15:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Tue, 12 Jun 2012 22:15:03 GMT) Full text and rfc822 format available.

Message #30 received at 677260@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Julien Cristau <jcristau@debian.org>
Cc: debian-bsd@lists.debian.org, 677260@bugs.debian.org
Subject: Re: Bug#677260: xserver-xorg-video-openchrome: FTBFS[kfreebsd]: error: unknown type name 'uint8_t'
Date: Tue, 12 Jun 2012 23:12:47 +0100
My other guess would be this, which also works;  would appreciate advice
from others on debian-bsd@ though:

--- /usr/include/libdrm/drm.h.orig
+++ /usr/include/libdrm/drm.h
@@ -46,14 +46,14 @@

 #include <sys/ioccom.h>
 #include <sys/types.h>
-typedef int8_t   __s8;
-typedef uint8_t  __u8;
-typedef int16_t  __s16;
-typedef uint16_t __u16;
-typedef int32_t  __s32;
-typedef uint32_t __u32;
-typedef int64_t  __s64;
-typedef uint64_t __u64;
+typedef __int8_t   __s8;
+typedef __uint8_t  __u8;
+typedef __int16_t  __s16;
+typedef __uint16_t __u16;
+typedef __int32_t  __s32;
+typedef __uint32_t __u32;
+typedef __int64_t  __s64;
+typedef __uint64_t __u64;
 typedef unsigned long drm_handle_t;

 #endif

Thanks!
Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#677260; Package src:xserver-xorg-video-openchrome. (Tue, 12 Jun 2012 23:33:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Tue, 12 Jun 2012 23:33:07 GMT) Full text and rfc822 format available.

Message #35 received at 677260@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Julien Cristau <jcristau@debian.org>
Cc: debian-bsd@lists.debian.org, 677260@bugs.debian.org
Subject: Re: Bug#677260: xserver-xorg-video-openchrome: FTBFS[kfreebsd]: error: unknown type name 'uint8_t'
Date: Wed, 13 Jun 2012 00:31:54 +0100
[Message part 1 (text/plain, inline)]
tags 677260 + patch
thanks

Hi,

I believe the attached patch to be an appropriate fix.  I think userland
should consider stdint.h a prerequisite of using via_drm.h;  and I'm
also assuming that all supported platforms will have it.  The intel
driver makes that assumption already.

Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org
[20-BSD-stdint-prerequisite.diff (text/x-patch, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#677260; Package src:xserver-xorg-video-openchrome. (Wed, 13 Jun 2012 20:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Robert Millan <rmh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Wed, 13 Jun 2012 20:12:03 GMT) Full text and rfc822 format available.

Message #40 received at 677260@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@debian.org>
To: Steven Chamberlain <steven@pyro.eu.org>
Cc: Julien Cristau <jcristau@debian.org>, debian-bsd@lists.debian.org, 677260@bugs.debian.org
Subject: Re: Bug#677260: xserver-xorg-video-openchrome: FTBFS[kfreebsd]: error: unknown type name 'uint8_t'
Date: Wed, 13 Jun 2012 22:10:08 +0200
2012/6/13 Steven Chamberlain <steven@pyro.eu.org>:
> My other guess would be this, which also works;  would appreciate advice
> from others on debian-bsd@ though:

It's basically up to libdrm-dev maintainers.  Do they expect that
stdint.h is a prerequisite before including drm.h?

On FreeBSD, including <sys/types.h> also gives you <stdint.h>. But
that doesn't apply to GNU systems.  This looks like a simple
portability issue.

I think the best solution is to include <stdint.h> from drm.h.
<stdint.h> is the only header that garantees uintXX_t types (as per
POSIX).

-- 
Robert Millan




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#677260; Package src:xserver-xorg-video-openchrome. (Wed, 13 Jun 2012 20:18:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Wed, 13 Jun 2012 20:18:04 GMT) Full text and rfc822 format available.

Message #45 received at 677260@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: Robert Millan <rmh@debian.org>
Cc: Steven Chamberlain <steven@pyro.eu.org>, debian-bsd@lists.debian.org, 677260@bugs.debian.org
Subject: Re: Bug#677260: xserver-xorg-video-openchrome: FTBFS[kfreebsd]: error: unknown type name 'uint8_t'
Date: Wed, 13 Jun 2012 22:14:10 +0200
On Wed, Jun 13, 2012 at 22:10:08 +0200, Robert Millan wrote:

> 2012/6/13 Steven Chamberlain <steven@pyro.eu.org>:
> > My other guess would be this, which also works;  would appreciate advice
> > from others on debian-bsd@ though:
> 
> It's basically up to libdrm-dev maintainers.  Do they expect that
> stdint.h is a prerequisite before including drm.h?
> 
No.

> On FreeBSD, including <sys/types.h> also gives you <stdint.h>. But
> that doesn't apply to GNU systems.  This looks like a simple
> portability issue.
> 
I'd rather that got fixed in kfreebsd, unless there's a good reason to
differ here.

> I think the best solution is to include <stdint.h> from drm.h.
> <stdint.h> is the only header that garantees uintXX_t types (as per
> POSIX).
> 
Cheers,
Julien




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#677260; Package src:xserver-xorg-video-openchrome. (Wed, 13 Jun 2012 20:24:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Robert Millan <rmh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Wed, 13 Jun 2012 20:24:05 GMT) Full text and rfc822 format available.

Message #50 received at 677260@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@debian.org>
To: Julien Cristau <jcristau@debian.org>
Cc: Steven Chamberlain <steven@pyro.eu.org>, debian-bsd@lists.debian.org, 677260@bugs.debian.org
Subject: Re: Bug#677260: xserver-xorg-video-openchrome: FTBFS[kfreebsd]: error: unknown type name 'uint8_t'
Date: Wed, 13 Jun 2012 22:22:23 +0200
2012/6/13 Julien Cristau <jcristau@debian.org>:
>> On FreeBSD, including <sys/types.h> also gives you <stdint.h>. But
>> that doesn't apply to GNU systems.  This looks like a simple
>> portability issue.
>>
> I'd rather that got fixed in kfreebsd, unless there's a good reason to
> differ here.

I'm not sure what you mean here.  You want <sys/types.h> to define
uintXX_t?  Then you need to request this to Glibc maintainers.

Or perhaps you want to emulate a FreeBSD-like build environment,
regardless of GNU <sys/types.h> behaviour?  There's a package
specifically for this purpose: freebsd-glue.

-- 
Robert Millan




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#677260; Package src:xserver-xorg-video-openchrome. (Wed, 13 Jun 2012 20:33:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Wed, 13 Jun 2012 20:33:03 GMT) Full text and rfc822 format available.

Message #55 received at 677260@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: Robert Millan <rmh@debian.org>
Cc: Steven Chamberlain <steven@pyro.eu.org>, debian-bsd@lists.debian.org, 677260@bugs.debian.org
Subject: Re: Bug#677260: xserver-xorg-video-openchrome: FTBFS[kfreebsd]: error: unknown type name 'uint8_t'
Date: Wed, 13 Jun 2012 22:31:16 +0200
On Wed, Jun 13, 2012 at 22:22:23 +0200, Robert Millan wrote:

> 2012/6/13 Julien Cristau <jcristau@debian.org>:
> >> On FreeBSD, including <sys/types.h> also gives you <stdint.h>. But
> >> that doesn't apply to GNU systems.  This looks like a simple
> >> portability issue.
> >>
> > I'd rather that got fixed in kfreebsd, unless there's a good reason to
> > differ here.
> 
> I'm not sure what you mean here.  You want <sys/types.h> to define
> uintXX_t?  Then you need to request this to Glibc maintainers.
> 
Yes, I'd like kfreebsd sys/types.h to look like freebsd sys/types.h.

> Or perhaps you want to emulate a FreeBSD-like build environment,
> regardless of GNU <sys/types.h> behaviour?  There's a package
> specifically for this purpose: freebsd-glue.
> 
How is one supposed to use that?  By passing -I/usr/include/freebsd to
gcc?

Cheers,
Julien




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#677260; Package src:xserver-xorg-video-openchrome. (Fri, 15 Jun 2012 16:48:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Robert Millan <rmh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Fri, 15 Jun 2012 16:48:03 GMT) Full text and rfc822 format available.

Message #60 received at 677260@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@debian.org>
To: Julien Cristau <jcristau@debian.org>
Cc: Steven Chamberlain <steven@pyro.eu.org>, debian-bsd@lists.debian.org, 677260@bugs.debian.org
Subject: Re: Bug#677260: xserver-xorg-video-openchrome: FTBFS[kfreebsd]: error: unknown type name 'uint8_t'
Date: Fri, 15 Jun 2012 18:46:10 +0200
2012/6/13 Julien Cristau <jcristau@debian.org>:
>> I'm not sure what you mean here.  You want <sys/types.h> to define
>> uintXX_t?  Then you need to request this to Glibc maintainers.
>>
> Yes, I'd like kfreebsd sys/types.h to look like freebsd sys/types.h.

It seems you're regarding <sys/types.h> as a kernel-related header,
but this is not at all accurate.  Let me try to clarify things.

On FreeBSD, <sys/types.h> is a kernel header.  On GNU systems, it is
part of the C library.  Specifically in Debian, it is provided by
eglibc package.  Unlike many of the glibc headers from <bits/*>
hierarchy, <sys/types.h> is not kernel-specific at all.  It's the same
header for all glibc systems, regardless of their kernel.

As for kernel side of things, kFreeBSD provides its own set of
headers, which in Debian they're packaged as kfreebsd-kernel-headers.
<sys/types.h> is not among them.

In summary: none of this has anything to do with the kernel, it's a
pure userland issue.  The problem is simply that libdrm-dev attempts
to use uintXX_t without including the header that provides them.

>> Or perhaps you want to emulate a FreeBSD-like build environment,
>> regardless of GNU <sys/types.h> behaviour?  There's a package
>> specifically for this purpose: freebsd-glue.
>>
> How is one supposed to use that?  By passing -I/usr/include/freebsd to
> gcc?

Yes.  I fail to see how's that better than fixing a one-line bug [1].
That burden is not mine to carry though.

[1] http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=677260#25

-- 
Robert Millan




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#677260; Package src:xserver-xorg-video-openchrome. (Fri, 15 Jun 2012 17:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Fri, 15 Jun 2012 17:51:03 GMT) Full text and rfc822 format available.

Message #65 received at 677260@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: Robert Millan <rmh@debian.org>
Cc: Steven Chamberlain <steven@pyro.eu.org>, debian-bsd@lists.debian.org, 677260@bugs.debian.org
Subject: Re: Bug#677260: xserver-xorg-video-openchrome: FTBFS[kfreebsd]: error: unknown type name 'uint8_t'
Date: Fri, 15 Jun 2012 19:46:51 +0200
On Fri, Jun 15, 2012 at 18:46:10 +0200, Robert Millan wrote:

> In summary: none of this has anything to do with the kernel, it's a
> pure userland issue.  The problem is simply that libdrm-dev attempts
> to use uintXX_t without including the header that provides them.
> 
drm.h is a kernel header.  It includes other kernel headers;
<linux/types.h> on linux, <sys/types.h> on bsd.

Cheers,
Julien




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#677260; Package src:xserver-xorg-video-openchrome. (Fri, 15 Jun 2012 17:57:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Robert Millan <rmh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Fri, 15 Jun 2012 17:57:04 GMT) Full text and rfc822 format available.

Message #70 received at 677260@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@debian.org>
To: Julien Cristau <jcristau@debian.org>
Cc: Steven Chamberlain <steven@pyro.eu.org>, debian-bsd@lists.debian.org, 677260@bugs.debian.org
Subject: Re: Bug#677260: xserver-xorg-video-openchrome: FTBFS[kfreebsd]: error: unknown type name 'uint8_t'
Date: Fri, 15 Jun 2012 19:53:56 +0200
2012/6/15 Julien Cristau <jcristau@debian.org>:
> On Fri, Jun 15, 2012 at 18:46:10 +0200, Robert Millan wrote:
>
>> In summary: none of this has anything to do with the kernel, it's a
>> pure userland issue.  The problem is simply that libdrm-dev attempts
>> to use uintXX_t without including the header that provides them.
>>
> drm.h is a kernel header.  It includes other kernel headers;
> <linux/types.h> on linux, <sys/types.h> on bsd.

Are we talking about the same file?  I was referring to
/usr/include/libdrm/drm.h.

-- 
Robert Millan




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#677260; Package src:xserver-xorg-video-openchrome. (Fri, 15 Jun 2012 18:15:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Fri, 15 Jun 2012 18:15:03 GMT) Full text and rfc822 format available.

Message #75 received at 677260@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: Robert Millan <rmh@debian.org>
Cc: Steven Chamberlain <steven@pyro.eu.org>, debian-bsd@lists.debian.org, 677260@bugs.debian.org
Subject: Re: Bug#677260: xserver-xorg-video-openchrome: FTBFS[kfreebsd]: error: unknown type name 'uint8_t'
Date: Fri, 15 Jun 2012 20:11:30 +0200
On Fri, Jun 15, 2012 at 19:53:56 +0200, Robert Millan wrote:

> 2012/6/15 Julien Cristau <jcristau@debian.org>:
> > On Fri, Jun 15, 2012 at 18:46:10 +0200, Robert Millan wrote:
> >
> >> In summary: none of this has anything to do with the kernel, it's a
> >> pure userland issue.  The problem is simply that libdrm-dev attempts
> >> to use uintXX_t without including the header that provides them.
> >>
> > drm.h is a kernel header.  It includes other kernel headers;
> > <linux/types.h> on linux, <sys/types.h> on bsd.
> 
> Are we talking about the same file?  I was referring to
> /usr/include/libdrm/drm.h.
> 
Yes.

Cheers,
Julien




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#677260; Package src:xserver-xorg-video-openchrome. (Fri, 15 Jun 2012 18:18:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Robert Millan <rmh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Fri, 15 Jun 2012 18:18:03 GMT) Full text and rfc822 format available.

Message #80 received at 677260@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@debian.org>
To: Julien Cristau <jcristau@debian.org>
Cc: Steven Chamberlain <steven@pyro.eu.org>, debian-bsd@lists.debian.org, 677260@bugs.debian.org
Subject: Re: Bug#677260: xserver-xorg-video-openchrome: FTBFS[kfreebsd]: error: unknown type name 'uint8_t'
Date: Fri, 15 Jun 2012 20:16:49 +0200
2012/6/15 Julien Cristau <jcristau@debian.org>:
>> > drm.h is a kernel header.  It includes other kernel headers;
>> > <linux/types.h> on linux, <sys/types.h> on bsd.
>>
>> Are we talking about the same file?  I was referring to
>> /usr/include/libdrm/drm.h.
>>
> Yes.

Then you definitely don't want to be including <sys/types.h> as that's
a userland header in all Debian platforms.

If you want the kernel version of that header, it's in
<sys/kern/types.h>.  For this particular problem, I wouldn't recommend
it since uintXX_t assumption is clearly buggy, but it's your choice.

-- 
Robert Millan




Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#677260; Package src:xserver-xorg-video-openchrome. (Fri, 15 Jun 2012 19:18:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Fri, 15 Jun 2012 19:18:06 GMT) Full text and rfc822 format available.

Message #85 received at 677260@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Robert Millan <rmh@debian.org>
Cc: Julien Cristau <jcristau@debian.org>, debian-bsd@lists.debian.org, 677260@bugs.debian.org
Subject: Re: Bug#677260: xserver-xorg-video-openchrome: FTBFS[kfreebsd]: error: unknown type name 'uint8_t'
Date: Fri, 15 Jun 2012 20:15:51 +0100
2012/6/15 Julien Cristau <jcristau@debian.org>:
> drm.h is a kernel header.  It includes other kernel headers;
> <linux/types.h> on linux, <sys/types.h> on bsd.

libdrm's via_drm.h #includes "via_drmclient.h", which has to be provided
by the openchrome driver;  doesn't that imply this is for userland?  In
that file is a #include "stdint.h" which would get the uintXX_t
definitions, except the #include "drm.h" happens too soon.

That #include "drm.h" is a recent(ish) change that upstream FreeBSD
doesn't have.  That also didn't exist in the (working?) via_drm.h
bundled with xserver-xorg-video-openchrome 0.2.904+svn1050-1

Also, upstream's *_drm.h headers[1] don't include sys/types.h or
stdint.h either, yet some of them make use of the uintXX_t types, making
those definitions seem like a prerequisite.  I think that was hinted at
during the response to [2].

So my current thinking is that the openchrome driver is forgetting to
include stdint.h, but this has gone unnoticed because FreeBSD's
sys/types.h would have included it as a side-effect.

xserver-xorg-video-intel includes stdint.h (from intel.h) before any of
the libdrm headers.  The mga driver does likewise, indirectly getting
stdint.h from inttypes.h.

I still think my most recent patch for this[3] is right.

[1] http://svnweb.freebsd.org/base/head/sys/dev/drm/
[2]
http://us.generation-nt.com/answer/patch-linux-headers-include-linux-types-h-where-appropriate-help-206535612.html
[3]
http://bugs.debian.org/cgi-bin/bugreport.cgi?msg=35;filename=20-BSD-stdint-prerequisite.diff;att=1;bug=677260

Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org




Added tag(s) patch. Request was from Steven Chamberlain <steven@pyro.eu.org> to control@bugs.debian.org. (Thu, 21 Jun 2012 19:57:04 GMT) Full text and rfc822 format available.

Reply sent to Julien Cristau <jcristau@debian.org>:
You have taken responsibility. (Sat, 30 Jun 2012 10:57:05 GMT) Full text and rfc822 format available.

Notification sent to debian-bsd@lists.debian.org:
Bug acknowledged by developer. (Sat, 30 Jun 2012 10:57:10 GMT) Full text and rfc822 format available.

Message #92 received at 677260-close@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: 677260-close@bugs.debian.org
Subject: Bug#677260: fixed in xserver-xorg-video-openchrome 1:0.2.906-2
Date: Sat, 30 Jun 2012 10:54:43 +0000
Source: xserver-xorg-video-openchrome
Source-Version: 1:0.2.906-2

We believe that the bug you reported is fixed in the latest version of
xserver-xorg-video-openchrome, which is due to be installed in the Debian FTP archive:

xserver-xorg-video-openchrome-dbg_0.2.906-2_amd64.deb
  to main/x/xserver-xorg-video-openchrome/xserver-xorg-video-openchrome-dbg_0.2.906-2_amd64.deb
xserver-xorg-video-openchrome_0.2.906-2.diff.gz
  to main/x/xserver-xorg-video-openchrome/xserver-xorg-video-openchrome_0.2.906-2.diff.gz
xserver-xorg-video-openchrome_0.2.906-2.dsc
  to main/x/xserver-xorg-video-openchrome/xserver-xorg-video-openchrome_0.2.906-2.dsc
xserver-xorg-video-openchrome_0.2.906-2_amd64.deb
  to main/x/xserver-xorg-video-openchrome/xserver-xorg-video-openchrome_0.2.906-2_amd64.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 677260@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Julien Cristau <jcristau@debian.org> (supplier of updated xserver-xorg-video-openchrome package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Sat, 30 Jun 2012 12:21:58 +0200
Source: xserver-xorg-video-openchrome
Binary: xserver-xorg-video-openchrome xserver-xorg-video-openchrome-dbg
Architecture: source amd64
Version: 1:0.2.906-2
Distribution: unstable
Urgency: low
Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Changed-By: Julien Cristau <jcristau@debian.org>
Description: 
 xserver-xorg-video-openchrome - X.Org X server -- VIA display driver
 xserver-xorg-video-openchrome-dbg - X.Org X server -- VIA display driver -- debugging symbols
Closes: 677260
Changes: 
 xserver-xorg-video-openchrome (1:0.2.906-2) unstable; urgency=low
 .
   * Fix FTBFS on kfreebsd with patch from Steven Chamberlain (closes: #677260)
Checksums-Sha1: 
 87a57955ae79a28bf1915353668f5c634e764a20 2657 xserver-xorg-video-openchrome_0.2.906-2.dsc
 c00ffe7e313d1881a78f01d720cb209a46d1c7ac 11262 xserver-xorg-video-openchrome_0.2.906-2.diff.gz
 5f8a5811b7cc10e29a0dba79fcddc7f2fd8b79bc 205224 xserver-xorg-video-openchrome_0.2.906-2_amd64.deb
 12aba90ab95077456bb5ca9c1fd25b7118dab132 930844 xserver-xorg-video-openchrome-dbg_0.2.906-2_amd64.deb
Checksums-Sha256: 
 d024b301c8946bb80f7df633245f7dc9336fc1442098ad2f8d0ad0fc5ae4063f 2657 xserver-xorg-video-openchrome_0.2.906-2.dsc
 5922d2a68968d758e16599545fb2b653c2b4a5365b283ba1d1196599abcf388d 11262 xserver-xorg-video-openchrome_0.2.906-2.diff.gz
 0fed7d890a72ea20604b1232477633428eba7f1334173c5adf42f13dba7a05f3 205224 xserver-xorg-video-openchrome_0.2.906-2_amd64.deb
 c5ea83e0d7353f381689fbb9a59748cfa8c542914a8dc88a810317c1b7da50cd 930844 xserver-xorg-video-openchrome-dbg_0.2.906-2_amd64.deb
Files: 
 62a3891025a567800f610aed453a4a0a 2657 x11 optional xserver-xorg-video-openchrome_0.2.906-2.dsc
 7b7b25a2f3b8826cc3ba56c660aef23f 11262 x11 optional xserver-xorg-video-openchrome_0.2.906-2.diff.gz
 01f60a9848b1410f87b45dea857a51de 205224 x11 optional xserver-xorg-video-openchrome_0.2.906-2_amd64.deb
 d4b07cbdbfad7eea0e0f8c4717e80ca5 930844 debug extra xserver-xorg-video-openchrome-dbg_0.2.906-2_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCAAGBQJP7tXtAAoJEDEBgAUJBeQMhIAP/iTpVe8kKRa0vxGR7GA8h1aJ
U+axlbettLQxK7lmM8Ept3qFhXV1vaP2OkznnSPC7fDTTaR4GQmviy713ViKMB+O
IWPKCynvay+Dk444YerNKFVjBoPHfXsqs1io39bIOQUR1cMA8E6WtjypYsc4A+az
tdWaKFLH/13YGdu/Jyjx1ulvNjF8Vv90EJTRnjn86ofVwyStTXmYBHJElRu1ycCu
MsSsNdstE49mzWlL6dnVFwm4VT2SyVlAwwTFSwo57NOCuo/w9PADfWtX9GLXt/LN
JggvCGorZlve39QJLMiKgm8dJacRpa0IEkQdmkjWhwTIZ/OQKJ2KHlcQ+T5+HW4s
2VsFpqY9ywmA+hDABNfLujXxd2cJzsQAztaAqogxhih7YPs7PuZjNcJHZ1csiHfP
Jsu4UsPM+Gd1GasMqJW6+uJ7XL48DcvZp83i77BS5T3BnSiT8fNfUiMTAYKDqyCy
w6qw1p11x+ZK4l1k1yKESgif/RGdMVII53nLgZ1LGsiKVEz9KilGjKN3/TAN1g86
XBRwZgJ6hIyAeOKpMGVkUJMJQQy5PQWHpRL43MtulKG4xfpXKPlsL1+qC6jN6xKM
3oe5DhDdQN4Gmja6r1YTALGfsVNBQGNo/lquRdBnPCzdUbfTcU4rwLMmxQGuBxRv
hyq767T0OLJSz7KtRWrW
=LJjH
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 30 Aug 2012 07:27:34 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 19:02:01 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.